$(document).ready(function() {
  $("#pwd").keyup(function() {
    password_strength($("#progress-bar"), $(this).val());
    password_missmatch(
      $("#pwd"),
      $("#password-mismatch"),
      $("#confirm-pwd").val()
    );
  });
  $("#confirm-pwd").keyup(function() {
    password_missmatch($("#pwd"), $("#password-mismatch"), $(this).val());
  });

  $("#addUsergroupButton").click(function() {
    $("#AddUsergroupForm").show();
    $("#addUsergroupButton").hide();
  });
  $("#HideAddUsergroup").click(function() {
    $("#AddUsergroupForm").hide();
    $("#addUsergroupButton").show();
  });

  $(".editor").each(function() {
    var editor = new Jodit(this, {
      uploader: {
        url: "uploadimageFile",
        isSuccess: function(resp) {
          return resp;
        },
        process: function(resp) {
          editor.selection.insertImage(
            resp,
            null,
            editor.options.imageDefaultWidth
          );
          return {
            message: resp.message
          };
        }
      }
    });
  });

  $(".autocomplete").each(function() {
    var names = $("#" + this.id).data("array-list");
    if (!names || names == undefined || names == "") {
      console.log(
        "Invalid or missing " + this.name + " autocomplete array list"
      );
    } else {
      if (names) {
        autocomplete(this, names.split(","));
      }
    }
  });
});

function password_missmatch(pwd, element, confirm_password) {
  if (pwd.val() != confirm_password) {
    element.show();
  } else {
    element.hide();
  }
}
function password_strength(element, password) {
  var desc = [
    {
      width: "0px"
    },
    {
      width: "20%"
    },
    {
      width: "40%"
    },
    {
      width: "60%"
    },
    {
      width: "80%"
    },
    {
      width: "100%"
    }
  ];
  var descClass = [
    "",
    "bg-danger",
    "bg-danger",
    "bg-warning",
    "bg-success",
    "bg-success"
  ];
  var score = 0;

  if (password.length > 6) {
    score++;
  }

  if (password.match(/[a-z]/) && password.match(/[A-Z]/)) {
    score++;
  }

  if (password.match(/\d+/)) {
    score++;
  }

  if (password.match(/.[!,@,#,$,%,^,&,*,?,_,~,-,(,)]/)) {
    score++;
  }

  if (password.length > 10) {
    console.log(score);
    score++;
  }

  element
    .removeClass(descClass[score - 1])
    .addClass(descClass[score])
    .css(desc[score]);
}
function autocomplete(inp, arr) {
  var currentFocus;
  inp.addEventListener("input", function(e) {
    var a,
      b,
      i,
      val = this.value;
    closeAllLists();
    if (!val) {
      return false;
    }
    currentFocus = -1;
    a = document.createElement("DIV");
    a.setAttribute("id", this.id + "autocomplete-list");
    a.setAttribute("class", "autocomplete-items");
    this.parentNode.appendChild(a);
    for (i = 0; i < arr.length; i++) {
      if (arr[i].substr(0, val.length).toUpperCase() == val.toUpperCase()) {
        b = document.createElement("DIV");
        b.innerHTML = "<strong>" + arr[i].substr(0, val.length) + "</strong>";
        b.innerHTML += arr[i].substr(val.length);
        b.innerHTML += "<input type='hidden' value='" + arr[i] + "'>";
        b.addEventListener("click", function(e) {
          inp.value = this.getElementsByTagName("input")[0].value;
          closeAllLists();
        });
        a.appendChild(b);
      }
    }
  });
  inp.addEventListener("keydown", function(e) {
    var x = document.getElementById(this.id + "autocomplete-list");
    if (x) x = x.getElementsByTagName("div");
    if (e.keyCode == 40) {
      currentFocus++;
      addActive(x);
    } else if (e.keyCode == 38) {
      currentFocus--;
      addActive(x);
    } else if (e.keyCode == 13) {
      e.preventDefault();
      if (currentFocus > -1) {
        if (x) x[currentFocus].click();
      }
    }
  });
  function addActive(x) {
    if (!x) return false;
    removeActive(x);
    if (currentFocus >= x.length) currentFocus = 0;
    if (currentFocus < 0) currentFocus = x.length - 1;
    x[currentFocus].classList.add("autocomplete-active");
  }
  function removeActive(x) {
    for (var i = 0; i < x.length; i++) {
      x[i].classList.remove("autocomplete-active");
    }
  }
  function closeAllLists(elmnt) {
    var x = document.getElementsByClassName("autocomplete-items");
    for (var i = 0; i < x.length; i++) {
      if (elmnt != x[i] && elmnt != inp) {
        x[i].parentNode.removeChild(x[i]);
      }
    }
  }
  document.addEventListener("click", function(e) {
    closeAllLists(e.target);
  });
}
